<template>
  <NuxtLayout>
    <NuxtPage :key="$route.fullPath" />

    <noscript
      ><img
        height="1"
        width="1"
        style="display: none"
        src="https://www.facebook.com/tr?id=437744472564538&ev=PageView&noscript=1"
    /></noscript>
  </NuxtLayout>
</template>

<script setup lang="ts">
import "virtual:svg-icons-register";
import { ScrollTrigger } from "gsap/ScrollTrigger";
import Lenis from "@studio-freight/lenis";

useHead({
  title: "Ansar Yawar - Life Is an Upward Spiral",
  meta: [
    {
      name: "description",
      content: "The human-centric path for personal growth",
    },
  ],
  script: [
    {
      async: true,
      src: "/pixel.js",
    },
  ],
});

const route = useRoute();
let lenis = null as any;

watch(
  route,
  async () => {
    if (process.client) {
      if (lenis) {
        lenis.scrollTo(".main");
        lenis.stop();
        setTimeout(() => {
          lenis.start();
        }, 20);
      }

      setTimeout(() => {
        if (window !== null) {
          window.scrollTo(0, 0);
        }
      }, 10);
      // ScrollTrigger.getAll().forEach((ST) => ST.kill());
      // ScrollTrigger.refresh();
    }
  },
  { deep: true, immediate: true }
);

onMounted(() => {
  lenis = new Lenis({
    duration: 1.3,
    easing: (t) => Math.min(1, 1.001 - Math.pow(2, -10 * t)), // https://www.desmos.com/calculator/brs54l4xou
    //@ts-ignore
    direction: "vertical", // vertical, horizontal
    gestureDirection: "vertical", // vertical, horizontal, both
    mouseMultiplier: 1,
    touchMultiplier: 2,
    infinite: false,
  });

  if (window) {
    //@ts-ignore
    window.lenis = lenis;
    lenis.on("scroll", () => {});
    requestAnimationFrame(raf);
    window.history.scrollRestoration = "manual";


  }
  function raf(time: number) {
    lenis.raf(time);
    requestAnimationFrame(raf);
  }
});
</script>

<style src="~/assets/scss/index.scss" />

<style>
.page-enter-active,
.page-leave-active {
  transition: all 0.2s;
}
.page-enter-from,
.page-leave-to {
  opacity: 0;
}
</style>
